From 2a908e6e46f725022d5c4a332cfc1b7d43ec3d3b Mon Sep 17 00:00:00 2001
From: Philip Withnall <pwithnall@endlessos.org>
Date: Mon, 24 Oct 2022 16:43:23 +0100
Subject: [PATCH 14/26] tests: Disable some random instance tests of GVariants
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: 8bit

Building a `GVariant` using entirely random data may result in a
non-normally-formed `GVariant`. It’s always possible to read these
`GVariant`s, but the API might return default values for some or all of
their components.

In particular, this can easily happen when randomly generating the
offset tables for non-fixed-width container types.

If it does happen, bytewise comparison of the parsed `GVariant` with the
original bytes will not always match. So skip those checks.

Signed-off-by: Philip Withnall <pwithnall@endlessos.org>

Helps: #2121
---
 glib/tests/gvariant.c | 18 ++++++++++++------
 1 file changed, 12 insertions(+), 6 deletions(-)

diff --git a/glib/tests/gvariant.c b/glib/tests/gvariant.c
index fb56c83c0..67804e89d 100644
--- a/glib/tests/gvariant.c
+++ b/glib/tests/gvariant.c
@@ -1232,6 +1232,7 @@ random_instance_assert (RandomInstance *instance,
   GRand *rand;
   gint i;
 
+  g_assert_true (size == 0 || buffer != NULL);
   g_assert_cmpint ((gsize) buffer & ALIGN_BITS & instance->alignment, ==, 0);
   g_assert_cmpint (size, ==, instance->size);
 
@@ -1458,10 +1459,13 @@ test_maybe (void)
         g_variant_serialiser_serialise (serialised,
                                         random_instance_filler,
                                         (gpointer *) &instance, 1);
+
         child = g_variant_serialised_get_child (serialised, 0);
-        g_assert (child.type_info == instance->type_info);
-        random_instance_assert (instance, child.data, child.size);
+        g_assert_true (child.type_info == instance->type_info);
+        if (child.data != NULL)  /* could be NULL if element is non-normal */
+          random_instance_assert (instance, child.data, child.size);
         g_variant_type_info_unref (child.type_info);
+
         flavoured_free (serialised.data, flavour);
       }
   }
@@ -1593,8 +1597,9 @@ test_array (void)
             GVariantSerialised child;
 
             child = g_variant_serialised_get_child (serialised, i);
-            g_assert (child.type_info == instances[i]->type_info);
-            random_instance_assert (instances[i], child.data, child.size);
+            g_assert_true (child.type_info == instances[i]->type_info);
+            if (child.data != NULL)  /* could be NULL if element is non-normal */
+              random_instance_assert (instances[i], child.data, child.size);
             g_variant_type_info_unref (child.type_info);
           }
 
@@ -1759,8 +1764,9 @@ test_tuple (void)
             GVariantSerialised child;
 
             child = g_variant_serialised_get_child (serialised, i);
-            g_assert (child.type_info == instances[i]->type_info);
-            random_instance_assert (instances[i], child.data, child.size);
+            g_assert_true (child.type_info == instances[i]->type_info);
+            if (child.data != NULL)  /* could be NULL if element is non-normal */
+              random_instance_assert (instances[i], child.data, child.size);
             g_variant_type_info_unref (child.type_info);
           }
 
-- 
2.41.0


